明经CAD社区

 找回密码
 注册

QQ登录

只需一步,快速开始

搜索
查看: 2721|回复: 3

修改文字内容后不能保存???

[复制链接]
发表于 2011-12-3 00:14:02 | 显示全部楼层 |阅读模式

        //替换文字
        public static void RePlaceText(string fileName)
        {
            try
            {
                Database dbDwgFile = new Database(false, true);
                dbDwgFile.ReadDwgFile(fileName, System.IO.FileShare.ReadWrite, true, null);
                using (Transaction OldTrans = dbDwgFile.TransactionManager.StartTransaction())
                {
                    BlockTable bt = OldTrans.GetObject(dbDwgFile.BlockTableId, OpenMode.ForNotify) as BlockTable;
                    BlockTableRecord btr = OldTrans.GetObject(bt[BlockTableRecord.ModelSpace], OpenMode.ForNotify) as BlockTableRecord;
                    foreach (ObjectId id in btr)
                    {
                        if (id.IsErased)
                        {
                            continue;
                        }
                        Entity ent = OldTrans.GetObject(id, OpenMode.ForWrite) as Entity;
                        if (ent.GetType().Name == "DBText")
                        {
                            DBText text1 = ent as DBText;
                            if (text1.TextString.Contains("被替换"))
                            {
                                    text1.TextString = text1.TextString.Replace("被替换", "正在试验");
                            }
                        }
                        else if (ent.GetType().Name == "MText")
                        {
                            MText text1 = ent as MText;
                            if (text1.Contents.Contains("被替换"))
                            {
                                                              text1.Contents = text1.Contents.Replace("被替换", "正在试验");
                            }
                        }
                    }
                    OldTrans.Commit();
                }
              // dbDwgFile.Save();如果不注释掉, 这句会出错,请大家帮忙看下应该怎么写?
            }
            catch
            {
                System.Windows.Forms.MessageBox.Show("替换错误", "提示");
            }
            finally
            {
            }
        }





发表于 2011-12-3 02:03:26 | 显示全部楼层
public void SaveAs(string fileName, Autodesk.AutoCAD.DatabaseServices.DwgVersion version)
    Autodesk.AutoCAD.DatabaseServices.Database 的成员
-------------------------
使用这个试试
 楼主| 发表于 2011-12-3 10:26:08 | 显示全部楼层
dbDwgFile.SaveAs(fileName, DwgVersion.Current) 用这句可以了,感谢sieben ,昨晚研究这个问题到2点都没有搞出来,睡觉也不踏实,早晨起来第一件事就是看贴,现在灰常开心。
 楼主| 发表于 2011-12-3 10:26:51 | 显示全部楼层
不过能否解释一下为什么.save()会报错吗??
您需要登录后才可以回帖 登录 | 注册

本版积分规则

小黑屋|手机版|CAD论坛|CAD教程|CAD下载|联系我们|关于明经|明经通道 ( 粤ICP备05003914号 )  
©2000-2023 明经通道 版权所有 本站代码,在未取得本站及作者授权的情况下,不得用于商业用途

GMT+8, 2024-11-25 18:26 , Processed in 0.160180 second(s), 23 queries , Gzip On.

Powered by Discuz! X3.4

Copyright © 2001-2021, Tencent Cloud.

快速回复 返回顶部 返回列表